#include "widget.h"

Widget::Widget(QWidget *parent) : QWidget(parent) {
    edit1 = new QTextEdit("",this);
    edit2 = new QTextEdit("",this);
    edit2->setReadOnly(true);
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->addWidget(edit1);
    layout->addWidget(edit2);
    setLayout(layout);
    connect(edit1,SIGNAL(textChanged()),this,SLOT(slot1()));
}

void Widget::slot1() {
 //Разбить текст из edit1 на слова, вывести их
 //количество и отсортированный список уникальных слов
 //(с точностью до регистра символов)
 QString text = edit1->toPlainText();
  //текст из многострочного поля
 QRegExp reg("[\\s|\\n|\\r|\\.|,|!|\\?|:|;]+");
  //символы, считающиеся границами слов
 QStringList list =
  text.split(reg, QString::SkipEmptyParts);
  //разбить строку на слова, пропуская пустые
 int cnt = list.count();
 QString newtext = QString("Всего слов: ")+
                   QString::number(cnt)+"\n";
 list.removeDuplicates(); //Удалить дубли из списка
 list.sort(Qt::CaseInsensitive); //Отсортировать
 foreach (const QString &str, list) {
  newtext += str+"\n"; //Составить список по алфавиту
 }
 edit2->setText(newtext);
}

Widget::~Widget() {
 delete edit2; delete edit1;
}
